\newenvironment{itemize*}%
  {\begin{itemize}%
    \setlength{\itemsep}{0pt}%
    \setlength{\parskip}{0pt}}%
  {\end{itemize}}

\begin{tikzpicture}
  \begin{scope}[yslant=0.5, xslant=-1]
    % problem space
    \node [minimum height=16em, minimum width=16em]
          (ground) at (0,0) {};
    \begin{scope}[gnuplot, xscale=0.9275, yscale=0.9275,
                           xshift=-17.95em, yshift=-13.05em]
      \input{gravity.half.tex}
    \end{scope}
    \node [draw, dashed, yslant=0.5, xslant=-1,
           minimum height=4em, minimum width=4em]
           (base) at (-1.95,-1.95) {};
    % boards
    \foreach \x in {3,...,0}
      \foreach \y in {3,...,0} {
        \node [sboard] (board\x\y) at (\x,\y) {};
        \board(\x,\y);
      }
    % mapping
    \node [fboard] (fboard) at (0,0) {};
    \draw (base.south west)
          [black,decorate,thick,decoration={brace, amplitude=1em}]
          to
          (base.north west)
          node [black,midway,left=-0.25em,yshift=-2em,yslant=-0.5,xslant=1]
          {$25'\,latitude$};
    \draw (fboard.south west)
          [white,decorate,thick,decoration={brace, amplitude=1em}]
          to
          (fboard.north west)
          node [white,left=-2.5em,yshift=-3em,yslant=-0.5,xslant=1]
          {4.75cm};
    \draw (base.south west) [dashed] to (fboard.south west);
    \draw (base.south east) [dashed] to (fboard.south east);
    \draw (base.north west) [dashed] to (fboard.north west);
  \end{scope}

  % sub-population
  \node [rectangle, minimum height=21.75em, minimum width=21.75em] (inner-bigb)
         at (-4,5.5) {};
  \node [rectangle, draw, rounded corners,
         font=\footnotesize, fill=gray!20,
         very thick, draw=gray,
         minimum height=22em, minimum width=22em] (bigb) at (-4,5.5) {};
  % dashed scoping
  \draw [thick, dashed] (board03.south west) to (inner-bigb.south west);
  \draw [thick, dashed] (board03.south east) to (inner-bigb.south east);
  \begin{scope}[scale=8]
    \bflatboard(-0.5,0.6875);
  \end{scope}
  \node [rectangle, draw, rounded corners,
         font=\footnotesize, fill=blue!30,
         very thick, draw=blue,
         minimum height=18em, minimum width=18em] (subpop) at (-4,5.5) {};
  % local sub-population
  \node [rectangle, draw, rounded corners,
         font=\footnotesize, fill=green!30,
         very thick, draw=green,
         minimum height=8.5em, minimum width=8.5em,
         opacity=0.8] (subpop) at (-2.75,4.25) {};
  \node at (-2.75,5.25) {\textbf{Subpopulation}};
  \node [font=\footnotesize] at (-2.75,4.9) {(64 individuals)};
  % %% Gravity individuals, from gravity robustness run 45
  % 045+882073+x0x79965+**
  % 08909557432+9+6598507330y99965+**
  % 0y801-x417/0-399804++**
  % 188987880-38*8*+*
  % 25675y930-51x7558***
  % 51*y89363--52y+68679++**
  % 605/yy72581y+y894yy+y894**5*
  % +60805/976/39728***
  % 63+71/-0*8xy*2*961+8264*9*+*
  % /650+630465+1*7558***
  % *65273x999611x+*8y965+*9965+**
  % 7079*/36-322249+/8972***
  % -7589726248972***
  % 7//x5x0y61x-4+86+41846+4**5*
  % 8199+71/9-429965+**
  % 8*5/5+y+x674*6*y-8*
  % -90824/342*0939728***
  % 9-2*y19+96-58***
  % +x8x-476342+0-76+4**5*
  % x8x8/82*9*+y818264*9*+*
  % xx71**2072+y894**5*
  \texttt{
  \individual(-2.75, 3.25, ...79965+**);
  \individual(-2.75,  3.5, ...99965+**);
  \individual(-2.75, 3.75, ...9804++**);
  \individual(-2.75,    4, ...-38*8*+*);
  \individual(-2.75, 4.25, ...x7558***);
  \individual(-2.75,  4.5, ...8679++**);
  \individual(-2.75,    3, ...y894**5*);}
  \node at (-2.75,8) {\textbf{RPN Evaluation}};
  {\footnotesize
    \texttt{
      \path [decorate, decoration={text along path,text={9728***}}]
            (-4,7.25) to (-3,7.25);
      \node [rectangle, draw, thick, draw=black, text width=1em,
             minimum height=3em, minimum width=1em]
             (stack)
             at (-2.75,6.625) {\ \\ 34 12};
      \draw [thick, ->, bend left=45] (-3,7.35) to (stack.north);
    }
    \node at (-2,7.125) {\footnotesize{stack}};
  }
  \node at (-5.5,3.75)  {\textbf{Tournament}};
  {\footnotesize
    \texttt{
      \path [decorate, decoration={text along path,text={*6*y-8*}}]
            (-6.25,3.075) to (-4.75,3.075);
      \draw [thick, ->, bend left=22.5]  (-4.125,3)      to (-5,3);
      \draw [thick, ->, bend right=22.5] (-4.125,3.25)   to (-5,3.25);
      \draw [thick, ->]                  (-4.125,3.125) to (-5,3.125);
    }
  }
  \node at (-5.5,6.5) {\textbf{Crossover}};
  {\footnotesize
    \texttt{
      \path [decorate, decoration={text along path,
             text={y+x674*6*y-8*}}]
            (-6.5,6.125) cos (-5.5,5.75) sin (-4.5,5.375);
      \path [decorate, decoration={text along path,
             text={1/9-429965+**}}]
            (-6.5,5.375)    cos (-5.5,5.75) sin (-4.5,6.125);
      \draw [thick, ->] (-5.5,5.55) to (-5.5,4.925);
      \path [decorate, decoration={text along path, text={y+x6749965+**}}]
            (-6.525,4.75) to (-4.5,4.75);
      \path [decorate, decoration={text along path, text={1/9-42*6*y-8*}}]
            (-6.525,4.375) to (-4.5,4.375);
    }
  }
  \node at (-5.5,8) {\textbf{Mutation}};
  {\footnotesize
    \texttt{
      \path [decorate, decoration={text along path, text={0-51x7y58***}}]
            (-6.525,7.5) to (-4.5,7.5);
      \path [decorate, decoration={text along path, text={0-51x7558***}}]
            (-6.525,7) to (-4.5,7);
      \draw [thick, ->] (-5.525,7.45) to (-5.525,7.2);
    }
  }

  % board description
  %%% \node [board] at (5.25,9) {};
  %%% \flatboard(5.25,9);
  \node [text width=18.5em] (bd) at (8.25,7.825)
        {{\large Hardware Tile}
          \vspace{-4pt}
          \begin{itemize*}
          \item 70MHz ARM7TDMI MCU
          \item 32KB RAM, 16KB EEPROM % 512KB Flash
          \item 128KB problem data storage
          \item hardware timers
          \item power sharing, 4 serial ports
          \end{itemize*}};

  % Software description
  \node [text width=18.5em, font=\tiny] (pec-process) at (8.25,4.325) {
    \large{Software Process}\\
    \vspace{-10pt}
    {\footnotesize
      \begin{tabbing}
        $\forall$ \= evolutionary tile\\
        \> randomly create an \emph{initial population}\\
        \> \textbf{for} \= \textbf{ever, concurrently}\\
        \> \> \textbf{with} \= \textbf{frequency} $f_m$\\
        \> \> \> \emph{select} one individual and \emph{mutate}\\
        \> \> \textbf{with} \= \textbf{frequency} $f_c$\\
        \> \> \> \emph{select} two individuals and \emph{crossover}\\
        \> \> \textbf{with} \= \textbf{frequency} $f_s$\\
        \> \> \> \emph{select} one individual and \emph{share}\\
        \> \> \textbf{with} \= \textbf{frequency} $f_d$
                               \textbf{if} \emph{collecting\_data}\\
        \> \> \> report statistics to central collector
      \end{tabbing}
    }
  };

  % Real Time Genetic Operator time lines
  \node [text width=12em] (rtgp-tl) at (2.625,8.5)
    {Real Time Genetic\\ Operator Timelines};
  \begin{scope}[yslant=0.5, xslant=-1]
    %% sub-pop time line
    \draw [->] (3,1) -- (9,7);
    \draw [->] (3,0) -- (9,6);
    \foreach \tick in {0,0.25,...,5.75} {
      \draw (3+\tick,1+\tick) -- (3+\tick+0.1,1+\tick-0.1);
      \draw (3+\tick,0+\tick) -- (3+\tick+0.1,0+\tick-0.1);
    }
    \foreach \z in {4.5}{
      \draw (3+\z+0.1,0+\z-0.1) [gray,decorate,thick,decoration={brace}]
            to
            (3+\z+0.1-0.25,0+\z-0.25-0.1)
            node [black, right=0em, midway, text width=8em]
            {25 ms};
    }
    \foreach \z in {1,...,5}{
      % mutation
      \draw (2.9+\z,-0.1+\z) to [mut-op, bend right=90, <-] (3.1+\z,0.1+\z);
      \draw (2.9+\z,-0.1+\z) to [mut-op, bend left=90]      (3.1+\z,0.1+\z);
      \draw (2.9+\z,0.9+\z) to [mut-op, bend right=90, <-] (3.1+\z,1.1+\z)
        node (mut\z) {};
      \draw (2.9+\z,0.9+\z) to [mut-op, bend left=90]      (3.1+\z,1.1+\z);
    }
    \foreach \z in {0.5,5.5}{
      % crossover
      \draw (2.9+\z,-0.1+\z) to [mut-op, bend right=90, <->] (3.1+\z,0.1+\z);
      \draw (2.9+\z,-0.1+\z) to [mut-op, bend left=90, <->] (3.1+\z,0.1+\z);
    }
    \foreach \z in {2.5}{
      \draw (2.9+\z,0.9+\z) to [mut-op, bend right=90, <->] (3.1+\z,1.1+\z);
      \draw (2.9+\z,0.9+\z) to [mut-op, bend left=90, <->] (3.1+\z,1.1+\z)
        node (cross\z) {};
    }
    % sharing
    \foreach \z in {3.5}{
      \draw (3+\z,0+\z) to [thick,->,bend right=45] (3+\z,1+\z)
        node (share\z) {};
    }
    % labels
    \node[align=centered, text width=6em, font=\footnotesize, left of=mut5]
         {~~mutation\\ ($f_m=20Hz$)};
    \node[align=centered, text width=5.5em, font=\footnotesize, left of=cross2.5]
         {~crossover\\ ($f_c=10Hz$)};
    \node[align=centered, text width=6em, font=\footnotesize, left of=share3.5]
         {~~~~sharing\\ ($f_s=0.1Hz$)};
  \end{scope}
  \node [font=\large] at (7,2) {Computational Space};
  \node [text width=18.5em, font=\footnotesize] at (8.5,1.5){
    Sample geometry: Sixteen $4.75cm \times 4.75cm$ tiles arranged in
    a $4 \times 4$ square.
  };
  \draw [dashed] (3.5,1) to (11,1);
  \node [font=\large] at (6.5,0.65) {Problem Space};
  \node [text width=18.5em, font=\footnotesize] at (8.5,-1.125){
    Sample fitness function: Gravity data from the state of Montana.
    Each hardware tile covers $25'\,latitude \times 25'\,longitude$
    mapped using the `\emph{local disjoint}' spatial mapping.  The size
    and shape of the total covered area is determined by the number
    and configuration of the hardware tiles, and by the scale and
    scheme used to map the hardware space to the problem space.
  };
\end{tikzpicture}
